;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						OppenComPort_2()				; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
OpenComPort_2(exPort,exBaud,exParity,exSysTimeOut,exByteTimeOut,exMultipleTimeOut)
{
	global outErr
	VarSetCapacity(outErr,255,0)
		
	ReadIntervalTimeout 		= %exByteTimeOut%
	ReadTotalTimeoutMultiplier  = %exMultipleTimeOut%
	ReadTotalTimeoutConstant	= %exSysTimeOut%
	WriteTotalTimeoutMultiplier = 1
	WriteTotalTimeoutConstant	= 100
		
	VarSetCapacity(Data, 20, 0)
	NumPut(ReadIntervalTimeout, Data, 0, "UInt")
	NumPut(ReadTotalTimeoutMultiplier, Data, 4, "UInt")
	NumPut(ReadTotalTimeoutConstant, Data, 8, "UInt")
	NumPut(WriteTotalTimeoutMultiplier, Data, 12, "UInt")
	NumPut(WriteTotalTimeoutConstant, Data, 16, "UInt")
	
	mode= baud=%exBaud% parity=%exParity% data=8 stop=1 dtr=on rts=on
	
	stringmid exPort, exPort, 4, 2	
	if !DllCall("M200\_eOpen", "Int", exPort, "str", mode, "Int", &Data, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						DisconnectGsmModem_2				;   GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
DisconnectGsmModem_2()
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M200\_eDisconnectGSM", "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						OpenTcpPort_2()					; tcp/ip-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
OpenTcpPort_2(exPort, ipAddress, Delay)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eTcpOpen", "Int", exPort, "str", ipAddress, "Int", StrLen(ipAddress), "Int", Delay, "str", outErr, "char")
		return false
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSoftVersion_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSoftVersion_2(exAddr)
{
	global outErr, cSoftVersion= ,csvDate=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(softVersion,255,0)
	VarSetCapacity(svDate,255,0)
	
	if !DllCall("M200\_eReadSoftVersion", "Int", exAddr, "str", softVersion, "str", svDate, "str", outErr, "char")
		return false
	
	stringmid tempDD,svDate,3,2	;
	stringmid tempMM,svDate,5,2	;
	stringmid tempUU,svDate,7,2	;
	
	svDate = %tempDD%.%tempMM%.%tempUU%
	
	csvDate	:= svDate
	cSoftVersion := softVersion
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteEnergyLimit_21()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteEnergyLimit_21(exAddr,enRateLimit)
{
	global outErr
	VarSetCapacity(outErr,255,0)

	if !DllCall("M200\_eWriteEnergyLimit", "Int", exAddr, "Int", enRateLimit, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEnergyLimit_21()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEnergyLimit_21(exAddr)
{
	global outErr,cEnergyLimit_21=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(EnergyLimit,32,0)
					
	if !DllCall("M200\_eReadEnergyLimit", "Int", exAddr, "Int*", EnergyLimit, "str", outErr, "char")
		return false

	cEnergyLimit_21 := EnergyLimit
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSerialNumber_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSerialNumber_2(exAddr)
{
	global outErr, cSerialNumUI= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(serialNumber,255,0)
			
	if !DllCall("M200\_eReadSerialNumber", "Int", exAddr, "str", serialNumber, "str", outErr, "char")
		return false

	cSerialNumUI := serialNumber

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVoltageLiBattery_2()		;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVoltageLiBattery_2(exAddr)
{
	global outErr, clibatBattery= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(libatBattery,255,0)
			
	if !DllCall("M200\_eReadVoltageLiBattery", "Int", exAddr, "str", libatBattery, "str", outErr, "char")
		return false

	clibatBattery := libatBattery

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadOutputDate_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadOutputDate_2(exAddr)
{
	global outErr, cOutputDate=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(outputDate,255,0)
			
	if !DllCall("M200\_eReadOutputDate", "Int", exAddr, "str", outputDate, "str", outErr, "char")
		return false

	cOutputDate := outputDate

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadRunningTime_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadRunningTime_2(exAddr)
{
	global outErr, cTime_2= ,cbatTime=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(Time,255,0)
	VarSetCapacity(batTime,255,0)
			
	if !DllCall("M200\_eReadRunningTime", "Int", exAddr, "str", Time, "str", batTime, "str", outErr, "char")
		return false

	cTime_2 := Time
	cbatTime := batTime

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamTime_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamTime_2(exAddr)
{
	global outErr, cparamTime= ,cparamDate=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(paramTime,255,0)
	VarSetCapacity(paramDate,255,0)
			
	if !DllCall("M200\_eReadParamTime", "Int", exAddr, "str", paramTime, "str", paramDate, "str", outErr, "char")
		return false

	cparamTime := paramTime
	cparamDate := paramDate

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSignalLevel_2()				;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSignalLevel_2(exAddr)
{
	global outErr, cmodemNum= ,csysNum= ,csLevel=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(modemNum,255,0)
	VarSetCapacity(sysNum,255,0)
	VarSetCapacity(sLevel,255,0)
			
	if !DllCall("M200\_eReadSignalLevel", "Int", exAddr, "str", sysNum, "str", modemNum, "Int*", sLevel, "str", outErr, "char")
		return false

	cmodemNum := modemNum
	csysNum := sysNum
	csLevel := sLevel

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentTime_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentTime_2(exAddr)
{
	global outErr, cTime= ,cTime1= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(testTime,255,0)
	VarSetCapacity(testDate,255,0)
	VarSetCapacity(weekDay,255,0)
			
	if !DllCall("M200\_eReadCurrentTime", "Int", exAddr, "str", testTime, "str", testDate, "str", weekDay, "str", outErr, "char")
		return false
		
	
		
		
	cTime := testDate . A_Space . A_Space . testTime . A_Space . A_Space . weekDay
	cTime1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'>" . testDate . "</td>`n"
	cTime1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'>" . testTime . "</td>`n"
	cTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . weekDay . "</td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSeasonFlag_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSeasonFlag_2(exAddr)
{
	global outErr, cFlagAutoSeason=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(seasonFlag,255,0)
			
	if !DllCall("M200\_eReadSeasonFlag", "Int", exAddr, "Int*", seasonFlag, "str", outErr, "char")
		return false
		
	cFlagAutoSeason := seasonFlag
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVariantExecution_2()		;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVariantExecution_2(exAddr)
{
	global outErr, cpowerFlag= ,crelayFlag=, creppowerFlag=, creprelayFlag=,crelayFlag_TaskGroup=,creppowerFlag_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerFlag,4,0)
	VarSetCapacity(relayFlag,4,0)
	

	
	if !DllCall("M200\_eReadVariantExecution", "Int", exAddr, "Int*", powerFlag, "Int*", relayFlag, "str", outErr, "char")
		return false
		
	if (powerFlag = 1)
	{
		cpowerFlag = <tr><td class='style6'>  </td><td class='style5'></td></tr>
		creppowerFlag = <tr><td><td><td class="style10">  </td><td class="style9"></td>
		creppowerFlag_TaskGroup=  
	}	
	else
	{
		cpowerFlag = <tr><td class='style6'>  </td><td class='style5'></td></tr>
		creppowerFlag = <tr><td><td><td class="style10">  </td><td class="style9"></td>
		creppowerFlag_TaskGroup=  
	}	
		
	if (relayFlag = 1)
	{
		crelayFlag = <tr><td class='style6'></td><td class='style5'></td></tr>
		creprelayFlag = <tr><td><td><td class="style10"></td><td class="style9"></td></tr>
		crelayFlag_TaskGroup=  
	}	
	else
	{
		crelayFlag = <tr><td class='style6'></td><td class='style5'></td></tr>
		creprelayFlag = <tr><td><td><td class="style10"></td><td class="style9"></td></tr>
		crelayFlag_TaskGroup=  
	}	

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SynchronizaionTime_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SynchronizaionTime_2(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eSynchronizaionTime", "Int", exAddr,  "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetTransitionFlag_2()			;  .   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetTransitionFlag_2(exAddr,FlagAutoSeason)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eWriteSeasonFlag", "Int", exAddr, "Int", FlagAutoSeason, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamDisplay_2()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamDisplay_2(exAddr)
{
	global outErr,cIndParamsA= ,cIndAdd1= ,cIndAdd2= ,cIndAdd3=, cIndRateRep=, cIndAddRep1= , cInd1_TaskGroup= 
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(rateParams,255,0)
	VarSetCapacity(powerParams,4,0)
	VarSetCapacity(timeParams,4,0)
	VarSetCapacity(dateParams,4,0)
			
	if !DllCall("M200\_eReadParamDisplay", "Int", exAddr, "str", rateParams, "Int*", powerParams, "Int*", timeParams, "Int*", dateParams, "str", outErr, "char")
		return false
	
	loop 5
	{
		;  
		stringmid rateParams%A_Index%,rateParams,A_Index,1
	
		; 
		if A_Index = 1
			label = 1
		else if A_Index = 2
			label = 2	
		else if A_Index = 3
			label = 3
		else if A_Index = 4
			label = 4	
		else if A_Index = 5
			label = 
	
		; (A)
		if (rateParams%A_Index%=1)
		{
			cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='rateParams" . A_Index . "' checked>" . label . "</td></tr>`n"	
			cIndRateRep .= "<tr><td><td><td class='style10'>" . label . "&nbsp;&nbsp;</td><td class='style9'></td>"
			
			if (A_Index <> 5)
			cInd1_TaskGroup .= "T" . A_Index . ", "
			else
			cInd1_TaskGroup .= "S, "
		}		
		else 
		{
			cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='rateParams" . A_Index . "'>" . label . "</td></tr>`n"
			cIndRateRep .= "<tr><td><td><td class='style10'>" . label . "&nbsp;&nbsp;</td><td class='style9'></td>"
		}
	}
	
	
	; 
	if (powerParams=1)
	{
		cIndAdd1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd1' checked></td>`n"	
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		cInd1_TaskGroup .= "power, "
	}	
	else
	{
		cIndAdd1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd1'></td>`n"
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
	}
	
	; 
	if (timeParams=1)
	{
		cIndAdd2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd2' checked></td>`n"	
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"	
		cInd1_TaskGroup .= "time, "
	}
	else
	{
		cIndAdd2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd2'></td>`n"	
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"	
	}	
	
	; 
	if (dateParams=1)
	{
		cIndAdd3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd3' checked></td>`n"	
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		cInd1_TaskGroup .= "date, "
	}		
	else
	{
		cIndAdd3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd3'></td>`n"
		cIndAddRep1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
	}	
	
	if (cInd1_TaskGroup <>"")
	stringtrimright cInd1_TaskGroup,cInd1_TaskGroup,2
	else
	cInd1_TaskGroup := ""	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadIndicationTime_2()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadIndicationTime_2(exAddr)
{
	global outErr,cIndTime=, cIndTimeRep=, cIndTime_TaskGroup= 
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(indTime11,4,0)
	VarSetCapacity(indTime21,4,0)
	VarSetCapacity(indTime31,4,0)
	VarSetCapacity(indTime41,4,0)
		
	if !DllCall("M200\_eReadIndicationTime", "Int", exAddr, "Int*", indTime11, "Int*", indTime21, "Int*", indTime31, "Int*", indTime41, "str", outErr, "char")
		return false
		
	cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='indTime11' value='" . indTime11 . "' /></td><td class='style5'> </td></tr>`n"	
	cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='indTime21' value='" . indTime21 . "' /></td><td class='style5'> </td></tr>`n"	
	cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='indTime31' value='" . indTime31 . "' /></td><td class='style5'>, , </td></tr>`n"	
	cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='indTime41' value='" . indTime41 . "' /></td><td class='style5'> </td></tr>`n"	
	
	cIndTimeRep .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . indTime11 . " ()</td>"
	cIndTimeRep .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . indTime21 . " ()</td>"
	cIndTimeRep .= "<tr><td><td><td class='style10'>, , &nbsp;&nbsp;</td><td class='style9'>" . indTime31 . " ()</td>"
	cIndTimeRep .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . indTime41 . " ()</td>"	
	
	cIndTime_TaskGroup = %indTime11%, %indTime21%, %indTime31%, %indTime41%
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadAddParamDisplay_2()			; .  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadAddParamDisplay_2(exAddr)
{
	global outErr,cIndTime1= ,cIndAdd4= ,cIndAdd5= ,cIndAdd6= ,cIndAdd7= ,cIndAdd8= ,cIndAdd9= ,cIndAdd10=, cIndDelayRep=, cIndAddRep2=
	global cIndAdd4_TaskGroup =, cIndAdd5_TaskGroup =
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(rateFlag1,4,0)
	VarSetCapacity(UIFreqFlag1,4,0)
	VarSetCapacity(maxdumpFlag1,4,0)
	VarSetCapacity(cRunningFlag1,4,0)
	VarSetCapacity(batRunningFlag1,4,0)
	VarSetCapacity(pLimitFlag1,4,0)
	VarSetCapacity(enLimitFlag1,4,0)
	VarSetCapacity(delayTime1,4,0)
		
	if !DllCall("M200\_eReadAddParamDisplay", "Int", exAddr, "Int*", rateFlag1, "Int*", UIFreqFlag1, "Int*", maxdumpFlag1, "Int*", cRunningFlag1, "Int*", batRunningFlag1, "Int*", pLimitFlag1, "Int*", enLimitFlag1, "Int*", delayTime1, "str", outErr, "char")
		return false
		
	cIndTime1 .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='indTime51' value='" . delayTime1 . "' /></td><td class='style5'> </td></tr>`n"
	cIndDelayRep := "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . delayTime1 . " ()</td>"
	
	; 
	if (UIFreqFlag1=1)
	{
		cIndAdd5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd5' checked>., , .</td>`n"	
		cIndAddRep2 .= "<tr><td><td><td class='style10'>., , .&nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= "U/I/F, "
		cIndAdd5_TaskGroup .= "d1, "  
	}
	else
	{
		cIndAdd5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd5'>., , .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'>., , .&nbsp;&nbsp;</td><td class='style9'></td>"
	}	
	
	;  
	if (rateFlag1=1)
	{
		cIndAdd4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd4' checked>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'>. &nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= ".., "
		cIndAdd5_TaskGroup .= "d2, " 
	}	
	else
	{
		cIndAdd4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd4'>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'>. &nbsp;&nbsp;</td><td class='style9'></td>"
	}	
	
		
	; 
	if (maxdumpFlag1=1)
	{
		cIndAdd6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd6' checked></td>`n"	
		cIndAddRep2 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= "., "
		cIndAdd5_TaskGroup .= "d3, " 
	}
	else
	{
		cIndAdd6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd6'></td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
	}	
			
	;  
	if (pLimitFlag1=1)
	{
		cIndAdd7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd7' checked>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= "., "
		cIndAdd5_TaskGroup .= "d4, " 
	}	
	else
	{
		cIndAdd7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd7'>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
	}	
			
	;  
	if (enLimitFlag1=1)
	{
		cIndAdd8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd8' checked>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= ".., "
		cIndAdd5_TaskGroup .= "d5, " 
	}
	else
	{
		cIndAdd8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd8'>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
	}	
		
	;  
	if (cRunningFlag1=1)
	{
		cIndAdd9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd9' checked>. .</td>`n"	
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= ".., "
		cIndAdd5_TaskGroup .= "d6, " 
	}
	else
	{
		cIndAdd9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd9'>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
	}	
		
	;  
	if (batRunningFlag1=1)
	{
		cIndAdd10 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd10' checked>. .</td>`n"	
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
		
		cIndAdd4_TaskGroup .= ".., "
		cIndAdd5_TaskGroup .= "d7, " 
	}
	else
	{
		cIndAdd10 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='cIndAdd10'>. .</td>`n"
		cIndAddRep2 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'></td>"
	}	
		
	cIndAdd4_TaskGroup .= ".-" . delayTime1 . ", "
	cIndAdd5_TaskGroup .= "res[" .  delayTime1 . "]"

	
	if (cIndAdd4_TaskGroup <>"")
	stringtrimright cIndAdd4_TaskGroup,cIndAdd4_TaskGroup,2
	else
	cIndAdd4_TaskGroup := ""	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplay_2()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplay_2(exAddr,rateParams,powerParams,timeParams,dateParams)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eWriteParamDisplay", "Int", exAddr, "str", rateParams, "Int", powerParams, "Int", timeParams, "Int", dateParams, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteAddParamDisplay_2()		;   (.)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteAddParamDisplay_2(exAddr,rateFlag,UIFreqFlag,maxdumpFlag,cRunningFlag,batRunningFlag,pLimitFlag,enLimitFlag,delayTime)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eWriteAddParamDisplay", "Int", exAddr, "Int", rateFlag, "Int", UIFreqFlag, "Int", maxdumpFlag, "Int", cRunningFlag, "Int", batRunningFlag, "Int", pLimitFlag, "Int", enLimitFlag, "Int", delayTime, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteIndicationTime_2()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteIndicationTime_2(exAddr,indTime1,indTime2,indTime3,indTime4)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eWriteIndicationTime", "Int", exAddr, "Int", indTime1, "Int", indTime2, "Int", indTime3, "Int", indTime4, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadStorageBattery_2()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadStorageBattery_2(exAddr)
{
	global outErr, cenRate1= ,cenRate2= ,cenRate3= ,cenRate4=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRate1,255,0)
	VarSetCapacity(enRate2,255,0)
	VarSetCapacity(enRate3,255,0)
	VarSetCapacity(enRate4,255,0)
			
	if !DllCall("M200\_eReadStorageBattery", "Int", exAddr, "Int*", enRate1, "Int*", enRate2, "Int*", enRate3, "Int*", enRate4, "str", outErr, "char")
		return false
		
	setformat float,.2	
	cenRate1 := enRate1/100
	cenRate2 := enRate2/100
	cenRate3 := enRate3/100
	cenRate4 := enRate4/100
		
	setformat integer,d	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadStartDayEnergy_2()			;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadStartDayEnergy_2(exAddr)
{
	global outErr, cenRate1_a= ,cenRate2_a= ,cenRate3_a= ,cenRate4_a=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRate1,255,0)
	VarSetCapacity(enRate2,255,0)
	VarSetCapacity(enRate3,255,0)
	VarSetCapacity(enRate4,255,0)
			
	if !DllCall("M200\_eReadStartDayEnergy", "Int", exAddr, "Int*", enRate1, "Int*", enRate2, "Int*", enRate3, "Int*", enRate4, "str", outErr, "char")
		return false
		
	setformat float,.2	
	cenRate1_a := enRate1/100
	cenRate2_a := enRate2/100
	cenRate3_a := enRate3/100
	cenRate4_a := enRate4/100
		
	setformat integer,d	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMonthEnergy_2()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMonthEnergy_2(exAddr,monthNum)
{
	global outErr, cenRate11= ,cenRate21= ,cenRate31= ,cenRate41=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRate1,255,0)
	VarSetCapacity(enRate2,255,0)
	VarSetCapacity(enRate3,255,0)
	VarSetCapacity(enRate4,255,0)
				
	if !DllCall("M200\_eReadMonthEnergy", "Int", exAddr, "Int", monthNum, "Int*", enRate1, "Int*", enRate2, "Int*", enRate3, "Int*", enRate4, "str", outErr, "char")
		return false
		
	setformat float,.2	
	cenRate11 := enRate1/100
	cenRate21 := enRate2/100
	cenRate31 := enRate3/100
	cenRate41 := enRate4/100
	setformat integer,d	

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMonthEnergy_2_M206()		;     ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMonthEnergy_2_M206(exAddr,monthNum)
{
	global outErr, cenRate11= ,cenRate21= ,cenRate31= ,cenRate41=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRate1,255,0)
	VarSetCapacity(enRate2,255,0)
	VarSetCapacity(enRate3,255,0)
	VarSetCapacity(enRate4,255,0)
			
	if !DllCall("M200\_eReadMonthEnergy_M206", "Int", exAddr, "Int", monthNum, "Int*", enRate1, "Int*", enRate2, "Int*", enRate3, "Int*", enRate4, "str", outErr, "char")
		return false
		
	setformat float,6.3	
	cenRate11 := enRate1/100
	cenRate21 := enRate2/100
	cenRate31 := enRate3/100
	cenRate41 := enRate4/100
		
	setformat integer,d	
return true
}



;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadRateQuantity_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadRateQuantity_2(exAddr)
{
	global outErr, crateQuantity1=, crateQuantityRep= , NumTariff_TskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(rateQuantity1,4,0)
				
	if !DllCall("M200\_eReadRateQuantity", "Int", exAddr, "Int*", rateQuantity1, "str", outErr, "char")
		return false
	
	if (rateQuantity1 = 1)
	{
		crateQuantity1 = 
		(
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="1" checked><span class="style4">1</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="2"><span class="style4">2</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="3"><span class="style4">3</span></td>							
			</tr>
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="4"><span class="style4">4</span></td>							
			</tr>
		)
	}
	else if (rateQuantity1 = 2)
	{
		crateQuantity1 = 
		(
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="1"><span class="style4">1</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="2" checked><span class="style4">2</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="3"><span class="style4">3</span></td>							
			</tr>
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="4"><span class="style4">4</span></td>							
			</tr>
		)
	}
	else if (rateQuantity1 = 3)
	{
		crateQuantity1 = 
		(
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="1"><span class="style4">1</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="2"><span class="style4">2</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="3" checked><span class="style4">3</span></td>							
			</tr>
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="4"><span class="style4">4</span></td>							
			</tr>
		)
	}
	else if (rateQuantity1 = 4)
	{
		crateQuantity1 = 
		(
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="1"><span class="style4">1</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="2"><span class="style4">2</span></td>							
			</tr>	
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="3"><span class="style4">3</span></td>							
			</tr>
			<tr>
				<td>&nbsp</td>
				<td><input name="QuantTariff" type="radio" value="4" checked><span class="style4">4</span></td>							
			</tr>
		)
	}

	crateQuantityRep = <tr><td><td><td class="style10"> &nbsp;&nbsp;</td><td class="style9">%rateQuantity1%</td>
	NumTariff_TskGroup := rateQuantity1
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteRateQuantity_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteRateQuantity_2(exAddr,rateQuantity)
{
	global outErr
	VarSetCapacity(outErr,255,0)
					
	if !DllCall("M200\_eWriteRateQuantity", "Int", exAddr, "Int", rateQuantity, "str", outErr, "char")
		return false
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadRateScale_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadRateScale_2(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eReadRateScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false		
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteRateScale_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteRateScale_2(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eWriteRateScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadWeekendScale_2()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadWeekendScale_2(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eReadWeekendScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteWeekendScale_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteWeekendScale_2(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eWriteWeekendScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSecPowerProfile_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSecPowerProfile_2(exAddr,TimeStart,TimeEnd)
{
	global outErr
	global cCurTimeMass= ,cCurDateMass= ,cStWordMass= ,cpowerMass=
	VarSetCapacity(outErr,255,0)
		
	VarSetCapacity(CurTimeMass,32000,0)	;  
	VarSetCapacity(CurDateMass,32000,0)	;  
	VarSetCapacity(StWordMass,32000,0) 	;  (- )
	VarSetCapacity(powerMass,32000,0)	;  (; )
	VarSetCapacity(arr1,4,0)			;
	
	;TimeStart:="25.04.2011 00:00"		;  
	;TimeEnd:="25.04.2011 16:30"			; .
			
	if !DllCall("M200\_eReadSecPowerProfile", "Int", exAddr, "str", TimeStart, "str", TimeEnd,  "str", curTimeMass, "str", curDateMass, "str", stWordMass, "str", powerMass, "str", arr1, "str", outErr, "char")
		return false
		
	cCurTimeMass := CurTimeMass	
	cCurDateMass := CurDateMass 	
	cStWordMass := StWordMass
	cpowerMass := powerMass
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadReleMode_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadReleMode_2(exAddr)
{
	global outErr, cRelayFlag= ,cEnergyControlFlag= ,cPowerControl=, cRelayFlagRep=, cRelayFlag_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(releMode,4,0)
				
	if !DllCall("M200\_eReadReleMode", "Int", exAddr, "Int*", releMode, "str", outErr, "char")
		return false
	
	if (releMode = 0)
	{
		cRelayFlag = <input style="margin-top:10px;" name="RelayMode" type="radio" value="0" class="style5" checked /><span class="style5"></span><br><input name="RelayMode" type="radio" value="1" class="style5" /><span class="style5"></span><br><input name="RelayMode" type="radio" value="2" class="style5"/><span class="style5">.  </span><br>
		cRelayFlagRep=<tr><td><td><td class="style10"> &nbsp;&nbsp;</td><td class="style9"></td>
		
		cRelayFlag_TaskGroup = .
	}
	else if (releMode = 1)
	{
		cRelayFlag = <input style="margin-top:10px;" name="RelayMode" type="radio" value="0" class="style5" /><span class="style5"></span><br><input name="RelayMode" type="radio" value="1" class="style5" checked /><span class="style5"></span><br><input name="RelayMode" type="radio" value="2" class="style5"/><span class="style5">.  </span><br>
		cRelayFlagRep=<tr><td><td><td class="style10"> &nbsp;&nbsp;</td><td class="style9"></td>
		
		cRelayFlag_TaskGroup = .
	}
	else if (releMode = 2)
	{
		cRelayFlag = <input style="margin-top:10px;" name="RelayMode" type="radio" value="0" class="style5" /><span class="style5"></span><br><input name="RelayMode" type="radio" value="1" class="style5" /><span class="style5"></span><br><input name="RelayMode" type="radio" value="2" class="style5" checked /><span class="style5">.  </span><br>
		cRelayFlagRep=<tr><td><td><td class="style10"> &nbsp;&nbsp;</td><td class="style9">.  </td>
		
		cRelayFlag_TaskGroup =   
	}
	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadReleMode_2a()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadReleMode_2a(exAddr)
{
	global outErr, cRelayState=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(releMode,4,0)
				
	if !DllCall("M200\_eReadReleMode_2a", "Int", exAddr, "Int*", releMode, "str", outErr, "char")
		return false
	
	if (releMode = 1)
	cRelayState= <span style='margin:20px;color:green;'><b>!</b></span>
	else if (releMode = 0)
	cRelayState= <span style='margin:20px;color:red;'><b>!</b></span>	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteReleMode_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteReleMode_2(exAddr,releMode)
{
	global outErr
	VarSetCapacity(outErr,255,0)
					
	if !DllCall("M200\_eWriteReleMode", "Int", exAddr, "Int", releMode, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLimit_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLimit_2(exAddr)
{
	global outErr,cPowerLimit=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerLimit,32,0)
					
	if !DllCall("M200\_eReadPowerLimit", "Int", exAddr, "Int*", powerLimit, "str", outErr, "char")
		return false

	cPowerLimit := powerLimit
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEnergyLimit_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEnergyLimit_2(exAddr)
{
	global outErr,cEnergyLimit1= ,cEnergyLimit2= ,cEnergyLimit3= ,cEnergyLimit4= ,cLimitFlag=, cEnergyLimit_TaskGroup=,cEnergyLimitFlag_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRateLimitMass,255,0)
	VarSetCapacity(enLimitFlagMass,255,0)
	VarSetCapacity(arr,4,0)
					
	if !DllCall("M200\_eReadEnergyRateLimit", "Int", exAddr, "str", enRateLimitMass, "str", enLimitFlagMass, "str", arr, "str", outErr, "char")
		return false

	Loop parse, enRateLimitMass,;
	cEnergyLimit%A_Index% := A_LoopField
	
	cLimitFlag := enLimitFlagMass
	
	loop 4
	{
		stringleft flag%A_Index%,cLimitFlag,1		
		stringtrimleft cLimitFlag,cLimitFlag,1
	}
	
	cEnergyLimit_TaskGroup = T1(%cEnergyLimit1%), T2(%cEnergyLimit2%), T3(%cEnergyLimit3%), T4(%cEnergyLimit4%)
	cEnergyLimitFlag_TaskGroup = T1(%flag1%), T2(%flag2%), T3(%flag3%), T4(%flag4%)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteEnergyLimit_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteEnergyLimit_2(exAddr,enRateLimit1,enRateLimit2,enRateLimit3,enRateLimit4,enLimitFlag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	loop 6
	{
		var := strlen(enRateLimit1)
		
		if (var < 6)
		enRateLimit1 := "0" . enRateLimit1
		else
		break		
	}
	
	loop 6
	{
		var := strlen(enRateLimit2)
		
		if (var < 6)
		enRateLimit2 := "0" . enRateLimit2
		else
		break		
	}
	
	loop 6
	{
		var := strlen(enRateLimit3)
		
		if (var < 6)
		enRateLimit3 := "0" . enRateLimit3
		else
		break		
	}
				
	loop 6
	{
		var := strlen(enRateLimit4)
		
		if (var < 6)
		enRateLimit4 := "0" . enRateLimit4
		else
		break		
	}
			
	if !DllCall("M200\_eWriteEnergyRateLimit", "Int", exAddr, "str", enRateLimit1, "str", enRateLimit2, "str", enRateLimit3, "str", enRateLimit4, "str", enLimitFlag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLimit_2()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLimit_2(exAddr,powerLimit)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M200\_eWritePowerLimit", "Int", exAddr, "Int", powerLimit, "str", outErr "char")
		return false

return true
}

;-------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLimitMode_2()			;    
;-------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLimitMode_2(exAddr)
{
	global outErr,ccompareByte1= ,ccycleTime1= ,ccycleFlag1= ,cresFlag1=, cresFlagRep=, ccycleFlagRep=,cresFlag1_TaskGroup=,ccycleFlag1_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(compareByte1,4,0)
	VarSetCapacity(cycleTime1,4,0)
	VarSetCapacity(cycleFlag1,4,0)
	VarSetCapacity(resFlag1,4,0)
					
	if !DllCall("M200\_eReadPowerLimitMode", "Int", exAddr, "Int*", compareByte1, "Int*", cycleTime1, "Int*", cycleFlag1, "Int*", resFlag1, "str", outErr, "char")
		return false

	ccompareByte1 := compareByte1	
	ccycleTime1 := cycleTime1
		
	if (resFlag1=1)
	{
		cresFlag1 := "<input type='checkbox' id='check_FlagompareByte' name='FlagompareByte'  />"
		cresFlagRep:="<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		
		cresFlag1_TaskGroup = 
	}	
	else
	{
		cresFlag1 := "<input type='checkbox' id='check_FlagompareByte' name='FlagompareByte' checked />"
		cresFlagRep:="<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		
		cresFlag1_TaskGroup = 
	}	
	
	if (cycleFlag1=1)
	{
		ccycleFlag1 := "<input type='checkbox' id='check_FlagCycleTime' name='FlagCycleTime'  />"
		ccycleFlagRep:="<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		
		ccycleFlag1_TaskGroup =  
	}	
	else
	{
		ccycleFlag1 := "<input type='checkbox' id='check_FlagCycleTime' name='FlagCycleTime' checked />"
		ccycleFlagRep:="<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'></td>"
		
		ccycleFlag1_TaskGroup = 
	}	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLimitMode_2()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLimitMode_2(exAddr,compareByte,cycleTime,cycleFlag,resFlag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M200\_eWritePowerLimitMode", "Int", exAddr, "Int", compareByte, "Int", cycleTime, "Int", cycleFlag, "Int", resFlag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadOutputFunction_2()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadOutputFunction_2(exAddr,tmp_var)
{
	global outErr, cOutFlag= ,cOutFlagRep= ,cOutFlag_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(flag1,4,0)
				
	if !DllCall("M200\_eReadOutputFunction", "Int", exAddr, "Int*", flag1, "str", outErr, "char")
		return false
	
	if (tmp_var = 0)
	{
		if (flag1 = 0)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5" checked /><span class="style5">5000 .</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 .</span><br><input name="OutMode" type="radio" value="2" class="style5"/><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5"/><span class="style5"> </span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>5000 .</td>
			
			cOutFlag_TaskGroup = 5000 .
		}
		else if (flag1 = 1)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 .</span><br><input name="OutMode" type="radio" value="1" class="style5" checked /><span class="style5">10000 .</span><br><input name="OutMode" type="radio" value="2" class="style5"/><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5"/><span class="style5"> </span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>10000 .</td>
			
			cOutFlag_TaskGroup = 10000 .
		}
		else if (flag1 = 2)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 .</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 .</span><br><input name="OutMode" type="radio" value="2" class="style5" checked /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5"/><span class="style5"> </span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'> </td>
			
			cOutFlag_TaskGroup =  
		}
		else if (flag1 = 3)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 .</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 .</span><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" checked /><span class="style5"> </span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'> </td>
			
			cOutFlag_TaskGroup =  
		}		
	}
	else
	{
		if (flag1 = 0)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5" checked /><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" /><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5" /><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>5000 .</td>
		}
		else if (flag1 = 1)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" checked /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" /><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5" /><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>10000 .</td>
		}
		else if (flag1 = 2)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" checked /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" /><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5" /><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'> </td>
		}
		else if (flag1 = 3)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" checked/><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5" /><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'> </td>
		}
		else if (flag1 = 4)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" /><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5" checked /><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5"/><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>5000 . (. .)</td>
		}
		else if (flag1 = 5)
		{
			cOutFlag = <input style="margin-top:10px;" name="OutMode" type="radio" value="0" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="1" class="style5" /><span class="style5">10000 . (. .)</span><br><br><input name="OutMode" type="radio" value="2" class="style5" /><span class="style5"> </span><br><input name="OutMode" type="radio" value="3" class="style5" /><span class="style5"> </span><br><br><input name="OutMode" type="radio" value="4" class="style5"/><span class="style5">5000 . (. .)</span><br><input name="OutMode" type="radio" value="5" class="style5" checked/><span class="style5">10000 . (. .)</span><br>
			cOutFlagRep = <tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>10000 . (. .)</td>
		}
	
	}
	
	
	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteOutputFunction_2()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteOutputFunction_2(exAddr,flag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M200\_eWriteOutputFunction", "Int", exAddr, "Int", flag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadTimeOnOff_2()				;  ...
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadTimeOnOff_2(exAddr,param)
{
	global outErr, cparamTime= ,cparamDate=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass,255,0)
	VarSetCapacity(dateMass,255,0)
			
	if !DllCall("M200\_eReadTimeOnOff", "Int", exAddr, "Int", param, "str", timeMass, "str", dateMass, "str", outErr, "char")
		return false

	cparamTime := timeMass
	cparamDate := dateMass

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVoltageCurrentPower_2()		; , , 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVoltageCurrentPower_2(exAddr)
{
	global outErr, cmPower= ,cmCurrent= ,cmVoltage=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(mPower,255,0)
	VarSetCapacity(mCurrent,255,0)
	VarSetCapacity(mVoltage,255,0)
			
	if !DllCall("M200\_eReadVoltageCurrentPower", "Int", exAddr, "str", mVoltage, "str", mCurrent, "str", mPower, "str", outErr, "char")
		return false

	cmPower := mPower
	cmCurrent := mCurrent
	cmVoltage := mVoltage

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentPower_2_M206()		;   206
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentPower_2_M206(exAddr)
{
	global outErr, cmPowerQ= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(mPower,255,0)
			
	if !DllCall("M200\_eReadCurrentPower_M206", "Int", exAddr, "str", mPower, "str", outErr, "char")
		return false

	cmPowerQ := mPower
	
return true
}

;-------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadFrequency_2()				; 
;-------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadFrequency_2(exAddr)
{
	global outErr, cfrequency= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(frequency,255,0)
				
	if !DllCall("M200\_eReadFrequency", "Int", exAddr, "str", frequency, "str", outErr, "char")
		return false

	cfrequency := frequency
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadJournal_2()					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadJournal_2(exAddr,massNum)
{
	global outErr, cEventMass ,cTimeMass
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(eventMass,1500,0)
	VarSetCapacity(timeMass,1500,0)
	VarSetCapacity(arr,4,0)
		
	if! DllCall("M200\_eReadJournal", "Int", exAddr, "Int", massNum, "str", eventMass, "str", timeMass, "str", arr, "str", outErr, "char")
		return false
	
	cEventMass:=eventMass
	cTimeMass:=timeMass
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadJournalParam_2()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadJournalParam_2(exAddr,infName,fName)
{
	global outErr 
	VarSetCapacity(outErr,255,0)
	
	if	!DllCall("M200\_eReadParamJournal", "Int", exAddr, "str", infName, "str", fName, "str", outErr, "char")
		return false
	 
return true
}

;-------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMaxVoltage_2()					;  
;-------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMaxVoltage_2(exAddr)
{
	global outErr, cMaxVoltage, cMaxVoltageDate, cMaxrVoltage, cMaxrVoltageDate
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(maxVoltage,255,0)
	VarSetCapacity(maxrVoltage,255,0)
	VarSetCapacity(maxVoltageDate,255,0)
	VarSetCapacity(maxrVoltageDate,255,0)
		
	if! DllCall("M200\_eReadMaxVoltage", "Int", exAddr, "str", maxVoltageDate, "str", maxVoltage, "str", maxrVoltageDate, "str", maxrVoltage,"str", outErr, "char")
		return false
		
	cMaxVoltage:=maxVoltage
	cMaxVoltageDate:=maxVoltageDate	
	cMaxrVoltage:=maxrVoltage
	cMaxrVoltageDate:=maxrVoltageDate
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMaxCurrent_2()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMaxCurrent_2(exAddr)
{
	global outErr, cMaxCurrent, cMaxCurrentDate, cMaxrCurrent, cMaxrCurrentDate
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(maxCurrent,255,0)
	VarSetCapacity(maxrCurrent,255,0)
	VarSetCapacity(maxCurrentDate,255,0)
	VarSetCapacity(maxrCurrentDate,255,0)
		
	if! DllCall("M200\_eReadMaxCurrent", "Int", exAddr, "str", maxCurrentDate, "str", maxCurrent, "str", maxrCurrentDate, "str", maxrCurrent,"str", outErr, "char")
		return false
		
	cMaxCurrent:=maxCurrent
	cMaxCurrentDate:=maxCurrentDate	
	cMaxrCurrent:=maxrCurrent
	cMaxrCurrentDate:=maxrCurrentDate
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMaxPower_2()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMaxPower_2(exAddr)
{
	global outErr, cMaxPower, cMaxPowerDate, cMaxrPower, cMaxrPowerDate
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(maxPower,255,0)
	VarSetCapacity(maxrPower,255,0)
	VarSetCapacity(maxPowerDate,255,0)
	VarSetCapacity(maxrPowerDate,255,0)
		
	if! DllCall("M200\_eReadMaxPower", "Int", exAddr, "str", maxPowerDate, "str", maxPower, "str", maxrPowerDate, "str", maxrPower,"str", outErr, "char")
		return false
		
	cMaxPower:=maxPower
	cMaxPowerDate:=maxPowerDate	
	cMaxrPower:=maxrPower
	cMaxrPowerDate:=maxrPowerDate
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ResertMaxParam_2()			;  ,   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ResertMaxParam_2(exAddr, paramType)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	perem:=0
	
	if !DllCall("M200\_eResertMaxParam", "Int", exAddr, "Int", perem, "Int", paramType, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteCorrectionTime_2()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteCorrectionTime_2(exAddr, cTime)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if (cTime>31)
	{
		outErr:="   !"
		return false
	}
	
	if !DllCall("M200\_eWriteCorrectionTime", "Int", exAddr, "Int", cTime, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCorrectionTime_2()					;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCorrectionTime_2(exAddr)
{
	global outErr, cCorrectTime= 
	VarSetCapacity(outErr,255,0)
	
	if! DllCall("M200\_eReadCorrectionTime", "Int", exAddr, "Int*", cCorrectTime, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						CloseComPort					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
CloseComPort_2(exPort)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eClose", "Int", exPort, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ConnectGsmModem_2					;  GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ConnectGsmModem_2(PhoneNumber, InitStr, Delay)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eConfigurationGSM", "str", PhoneNumber, "str", InitStr, "Int", StrLen(InitStr), "Int", Delay, "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetEchoMode_2				;/ echo-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetEchoMode_2(echoMode)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M200\_eSetEchoMode", "Int", echoMode, "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetGSMFlag_2						;    GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetGSMFlag_2(gsmFlag)
{

	DllCall("M200\_eSetGSMFlag", "Int", gsmFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetEchoFlag_2						;  -
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetEchoFlag_2(echoFlag)
{
	DllCall("M200\_eSetEchoFlag", "Int", echoFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetTcpFlag_2						;  tcp/ip- 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetTcpFlag_2(tcpFlag)
{

	DllCall("M200\_eSetTcpFlag", "Int", tcpFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ConnectRFModem_2					;  RF
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ConnectRFModem_2(SerialNumber)
{
	global outErr
	
	;      
	loop 8
	{
		stringmid AscByte,SerialNumber,A_Index,1
		transform AscByte,Asc, %AscByte%
		
		SetFormat integer, hex
		AscByte += 0
	
		if (AscByte < 0x10)
		{
			stringright AscByte, AscByte, 1
			AscByte = 0%AscByte%
		}
				
		stringmid AscByte, AscByte, 3, 2
		
		if (A_Index = 1)
			AscStr= %AscByte%	
		else
			AscStr = %AscStr%%AscByte%				
	}
	
	;ATZ
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(outMass,255,0)
	cmdMass:="41 54 5a 0d"

	if !DllCall("M200\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false	
	
	;AT&D2
	cmdMass:="41 54 26 44 32 0d"	
	if !DllCall("M200\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false	

	;ATD........
	cmdMass:="41 54 44" . AscStr . "`0d"
	if !DllCall("M200\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false		
	
	SetFormat integer, d
	AscByte += 0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteAddress()						;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteAddress_2(exAddr,typeAddr,newAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M200\_eWriteAddress", "Int", exAddr, "Int", typeAddr, "Int", newAddr, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadStorageBattery_2_M206()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadStorageBattery_2_M206(exAddr)
{
	global outErr, cenRate1= ,cenRate2= ,cenRate3= ,cenRate4=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enRate1,255,0)
	VarSetCapacity(enRate2,255,0)
	VarSetCapacity(enRate3,255,0)
	VarSetCapacity(enRate4,255,0)
			
	if !DllCall("M200\_eReadStorageBattery_M206", "Int", exAddr, "Int*", enRate1, "Int*", enRate2, "Int*", enRate3, "Int*", enRate4, "str", outErr, "char")
		return false
		
	setformat float,6.3	
	cenRate1 := enRate1/100
	cenRate2 := enRate2/100
	cenRate3 := enRate3/100
	cenRate4 := enRate4/100
		
	setformat integer,d	
return true
}









